Subject: Re: to do for 2.4 (update 8)

From: Dominik Vogt <[email-masked]>
Date: Wed, 30 Jun 1999 03:47:03 +0200

On Tue, Jun 29, 1999 at 01:23:38AM -0400, Paul D. Smith wrote:
> First, note that I can reproduce these only with Emacs (I'm using GNU
> Emacs 20.3).  I couldn't reproduce it with xterm or rxvt, and it doesn't
> seem to happen with Netscape.
> 
>  1) Shuffling window :(.  Any Emacs frame with a negative geometry that
>     is iconified when the recapture command in that function is invoked,
>     will be offset some number of bytes to the left when you de-iconify
>     it.  For example, if I say:
> 
>       $ emacs -geometry -0+80
> 
>     then I see the problem.  If I use +0+80, it doesn't happen.  These
>     seems to only happen once, but if you kill the frame and recreated
>     it, then iconify, then recapture, it happens for the new frame
>     again.

Yes, I see that too (only with Emacs, not XEmacs). But it has nothing to
do with iconifying. What happens is this:

When emacs is mapped first, it sets this normal hints:

 x        408
 width    740
 gravity   NE

And

 border width 2

Let's assume fvwm uses a border width of 9. Then the frame window starts
2 * (9 - 2) = 14 pixels left from the original position, at x = 394 (the
old window border is removed and a new one is drawn within the frame).
But when emacs is mapped, it notices its new position and sets new normal
hints:

 x        401 <--
 width    740
 gravity   NW <--

This truly reflects the current client window location (which is
located at x = 403). Emacs wants to be clever but does not take the
WMs border width into account. Then we recapture the window and
the new frame is placed at 401 as requested (note that the gravity
has changed!). So the client portion of the frame begins at
401 + 9 = 410 which is (9 - 2) = 7 pixels too far right.

At this point I stopped debugging since it's clear now that emacs
is broken. THe is another effect that doubles the mis-placement so
that emacs ends up 14 pixels too far to the right.

I have reported this to the emacs people.

Bye

Dominik ^_^

--
Dominik Vogt, [email-masked]
Reply-To: [email-masked]
--
Visit the official FVWM web page at <URL:http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked]